unit readstats;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

Type
  TStats = Array[0..256] of Int64;
  Pstats = ^TStats;

  TDirectoryCallBack = Procedure (Const ADirectory : String) of object;


Function GetStats(Var Stats : TSTats; ADirectory,AExtensions : String; Recurse : Boolean) : Integer;
Function GetStats(Var Stats : TSTats; ADirectory,AExtensions : String; Recurse : Boolean; OnDirectoryDone : TDirectoryCallBack) : Integer;
Procedure Updatestats(Var Stats : TSTats; AFileName : String);

implementation

Function GetStats(Var Stats : TSTats; ADirectory,AExtensions : String; Recurse : Boolean) : Integer;
begin
  Result:=GetStats(Stats,ADirectory,AExtensions,Recurse,Nil);
end;

Function GetStats(Var Stats : TSTats; ADirectory,AExtensions : String; Recurse : Boolean; OnDirectoryDone : TDirectoryCallBack) : Integer;

Var
  Info : TSearchRec;
  E : String;

begin
  Result:=0;
  If FindFirst(ADirectory+'*.*',0,Info)=0 then
    try
      repeat
        E:=LowerCase(ExtractFileExt(Info.Name))+'.';
        If Pos(E,AExtensions)<>0 then
          begin
          inc(Result);
          UpdateStats(Stats,ADirectory+Info.Name);
          end;
      Until FindNext(Info)<>0;
    finally
      FindClose(Info);
    end;
  If Assigned(OnDirectoryDone) then
    OnDirectoryDone(ADirectory);
  if Recurse then
    If FindFirst(ADirectory+AllFilesMask,faDirectory,Info)=0 then
      try
        repeat
          if ((Info.Attr and faDirectory)<>0)
              and (Info.Name<>'..') and (info.name<>'.') then
            Result:=Result+GetStats(Stats,Adirectory+Info.Name+PathDelim,AExtensions,Recurse,OnDirectoryDone);
        Until FindNext(Info)<>0;
      finally
        FindClose(Info);
      end;
end;

Procedure Updatestats(Var Stats : TSTats; AFileName : String);

Const
  MaxSize = 1024 * 1024 * 10;

Var
  S : Array of Byte;
  b : Byte;
  P : PByte;
  I,R : Integer;
  F : THandle;

begin
  SetLength(S,MaxSize);
  F:=FileOpen(AFileName,fmopenRead or fmShareDenyWrite);
  if F<0 then exit;
  try
    Inc(Stats[256]);
    Repeat
      R:=FileRead(F,S[0],MaxSize);
      P:=PByte(@S[0]);
      For I:=1 to R do
        begin
        Inc(Stats[P^]);
        Inc(P);
        end;
    Until R<MaxSize;
  finally
    FileClose(F);
  end;
end;

end.

